package pistePK;

/**
 * Cette interface est utilisee par les machines pour visualiser le nom des joueurs
 * et enregistrer le nom des gagnants
 * Bien sur, chaque systeme peut implementer cette interface comme il le veut
 * En particulier pour retrouver le gagnant, et pas forcement avec seulement son nom.
 * @author blay
 */
public interface MatchInterface {

	/**
	 * Retourne le nom du joueur de gauche
	 * @return String
	 */
	public String getLeftPlayer();


	/**
	 * Retourne le nom du joueur de droite
	 * @return String
	 */
	String getRightPlayer();


	/**
	 * Enregistre le nom du joueur gagnant
	 *
	 */
	void setWinner(String matchWinner);
	
}
